# coding: utf-8

import sys
from setuptools import setup, find_packages

NAME = "telecoms_cloud"
VERSION = "1.0.0"



# To install the library, run the following
#
# python setup.py install
#
# prerequisite: setuptools
# http://pypi.python.org/pypi/setuptools

REQUIRES = ["urllib3 >= 1.10", "six >= 1.9", "certifi", "python-dateutil"]

setup(
    name=NAME,
    version=VERSION,
    description="Telecoms Cloud API",
    author_email="support@telecomscloud.com",
    url="",
    keywords=["Swagger", "Telecoms Cloud API"],
    install_requires=REQUIRES,
    packages=find_packages(),
    include_package_data=True,
    long_description="""\
    &lt;p&gt;Telecoms Cloud is a Telecoms engine for websites, mobile apps and Internet-enabled devices, otherwise known as the “Internet of Things”. It is an API-driven telecommunications platform which enables developers to incorporate scalable, highly-available telecoms functionality within their applications, using Telecoms Cloud’s global infrastructure, rather than investing in their own expensive and cumbersome hardware setup.&lt;/p&gt;\n\n&lt;p&gt;Using our REST API and just a few lines of code, developers can add functionality such as outbound calling, phone number provisioning, SMS, call recording, call queuing, IVR Menus, fax, voice conferencing and much more to their Internet connected device, mobile application or website, inspiring them to create feature-rich and capable functionality.&lt;/p&gt;
    """
)


