# coding: utf-8

"""
VApi.py
Copyright 2016 SmartBear Software

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
"""

from __future__ import absolute_import

import sys
import os

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class VApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def account_info(self, **kwargs):
        """
        Account Info
        Provides account information

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.account_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :return: AccountInfoResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method account_info" % key
                )
            params[key] = val
        del params['kwargs']


        resource_path = '/v1/account/info'.replace('{format}', 'json')
        method = 'GET'

        path_params = {}

        query_params = {}

        header_params = {}

        form_params = {}
        files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type='AccountInfoResponseModel',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def create_grant_client(self, create_grant_client, **kwargs):
        """
        Request an access token using client credentials
        Request an access token using client credentials. The returned access token can be used to make authenticated requests to any endpoint.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_grant_client(create_grant_client, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param CreateGrantClient create_grant_client: client_id : string - Unique client ID as issued by service provider. May be passed in query, body or along with client_secret in a basic auth header. client_secret : string - Client secret as issued by service provider. May be passed in json body or along with client_id in a basic auth header. (required)
        :return: ClientGrantResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['create_grant_client']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_grant_client" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'create_grant_client' is set
        if ('create_grant_client' not in params) or (params['create_grant_client'] is None):
            raise ValueError("Missing the required parameter `create_grant_client` when calling `create_grant_client`")

        resource_path = '/v1/authorization/oauth2/grant-client'.replace('{format}', 'json')
        method = 'POST'

        path_params = {}

        query_params = {}

        header_params = {}

        form_params = {}
        files = {}

        body_params = None
        if 'create_grant_client' in params:
            body_params = params['create_grant_client']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type='ClientGrantResponseModel',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def retrieve_info(self, last_pointer, **kwargs):
        """
        Received Fax Info
        Provides received fax information including the faxes Id which can be used to download the fax document and a 'pointer'. Make an initial request with the last_pointer parameter set to 0 (zero), this will return any items received within the last 48 hours, or an empty array if no items have been received. Each item record returned will include a 'pointer', to get updates received after the last check, pass the highest pointer seen.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.retrieve_info(last_pointer, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str last_pointer: Latest known pointer, faxes records received after this will be returned. Enter 0 if unknown or no previous pointer.. (required)
        :return: FaxInfoCollectionResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['last_pointer']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retrieve_info" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'last_pointer' is set
        if ('last_pointer' not in params) or (params['last_pointer'] is None):
            raise ValueError("Missing the required parameter `last_pointer` when calling `retrieve_info`")

        resource_path = '/v1/fax/inbound/info'.replace('{format}', 'json')
        method = 'GET'

        path_params = {}

        query_params = {}
        if 'last_pointer' in params:
            query_params['last_pointer'] = params['last_pointer']

        header_params = {}

        form_params = {}
        files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type='FaxInfoCollectionResponseModel',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def retrieve_fax(self, id, **kwargs):
        """
        
        Retrieve fax

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.retrieve_fax(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: ID (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retrieve_fax" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `retrieve_fax`")

        resource_path = '/v1/fax/inbound/{id}'.replace('{format}', 'json')
        method = 'GET'

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = {}
        files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept([])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def send_fax(self, to, _from, fax_document, **kwargs):
        """
        Submit a fax for sending
        Post a PDF file as fax_document. Returns unique id.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.send_fax(to, _from, fax_document, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str to: Number to send fax to. (required)
        :param str _from: Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading '+') or UK based number formatting by default. (required)
        :param file fax_document: Single PDF containing page(s) to be faxed. (required)
        :param str number_format_location: Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB.
        :return: FaxOutboundSendResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['to', '_from', 'fax_document', 'number_format_location']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method send_fax" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'to' is set
        if ('to' not in params) or (params['to'] is None):
            raise ValueError("Missing the required parameter `to` when calling `send_fax`")
        # verify the required parameter '_from' is set
        if ('_from' not in params) or (params['_from'] is None):
            raise ValueError("Missing the required parameter `_from` when calling `send_fax`")
        # verify the required parameter 'fax_document' is set
        if ('fax_document' not in params) or (params['fax_document'] is None):
            raise ValueError("Missing the required parameter `fax_document` when calling `send_fax`")

        resource_path = '/v1/fax/outbound'.replace('{format}', 'json')
        method = 'POST'

        path_params = {}

        query_params = {}
        if 'to' in params:
            query_params['to'] = params['to']
        if '_from' in params:
            query_params['from'] = params['_from']
        if 'number_format_location' in params:
            query_params['numberFormatLocation'] = params['number_format_location']

        header_params = {}

        form_params = {}
        files = {}
        if 'fax_document' in params:
            files['fax_document'] = params['fax_document']

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['multipart/form-data'])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type='FaxOutboundSendResponseModel',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def retrieve_fax_updates(self, **kwargs):
        """
        Get fax submission status updates
        Retrieve any status updates for fax submissions since last checked.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.retrieve_fax_updates(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str last_pointer: Optional pointer, if not used last two days will be returned.
        :return: FaxOutboundGetUpdatesCollectionResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['last_pointer']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retrieve_fax_updates" % key
                )
            params[key] = val
        del params['kwargs']


        resource_path = '/v1/fax/outbound/updates'.replace('{format}', 'json')
        method = 'GET'

        path_params = {}

        query_params = {}
        if 'last_pointer' in params:
            query_params['last_pointer'] = params['last_pointer']

        header_params = {}

        form_params = {}
        files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type='FaxOutboundGetUpdatesCollectionResponseModel',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def retrieve_fax_status(self, id, **kwargs):
        """
        Check the status of a submitted fax.
        Returns the status of the fax submission referenced by the passed Id

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.retrieve_fax_status(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Id of message to check as provided on submission of Fax. (required)
        :return: FaxOutboundGetStatusResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retrieve_fax_status" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `retrieve_fax_status`")

        resource_path = '/v1/fax/outbound/{id}/status'.replace('{format}', 'json')
        method = 'GET'

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = {}
        files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type='FaxOutboundGetStatusResponseModel',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def format_e164(self, number, location, **kwargs):
        """
        Get E.164 format number
        Provides an E.164 formatted (e.g. +441514962245) version of the provided national (e.g. 01514962245) format phone number

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.format_e164(number, location, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str number: National format phone number (e.g. 01514962245). (required)
        :param str location: Two letter country code matching the location the provided number is formatted for (e.g. US). (required)
        :param str pretty: Optional query parameter. If true, returned number will contain whitespace for readability (e.g. +44 151 496 2245).
        :return: NumberFormatterResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['number', 'location', 'pretty']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method format_e164" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'number' is set
        if ('number' not in params) or (params['number'] is None):
            raise ValueError("Missing the required parameter `number` when calling `format_e164`")
        # verify the required parameter 'location' is set
        if ('location' not in params) or (params['location'] is None):
            raise ValueError("Missing the required parameter `location` when calling `format_e164`")

        resource_path = '/v1/format/number/e164/{number}/{location}'.replace('{format}', 'json')
        method = 'GET'

        path_params = {}
        if 'number' in params:
            path_params['number'] = params['number']
        if 'location' in params:
            path_params['location'] = params['location']

        query_params = {}
        if 'pretty' in params:
            query_params['pretty'] = params['pretty']

        header_params = {}

        form_params = {}
        files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type='NumberFormatterResponseModel',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def format_international(self, number, provided_location, dial_from_location, **kwargs):
        """
        Get international format number
        Converts the provided National format number (e.g. 01514962245) into an dialable number in the provided location (e.g. 011441514962245 for dialing GB from US)

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.format_international(number, provided_location, dial_from_location, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str number: Phone number in National format (e.g. 01514962245). (required)
        :param str provided_location: Two letter country code matching provided number format (e.g. GB). (required)
        :param str dial_from_location: Two letter country code of location dialling from (e.g. US). (required)
        :param str pretty: Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 011 44 151 496 2245).
        :return: NumberFormatterResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['number', 'provided_location', 'dial_from_location', 'pretty']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method format_international" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'number' is set
        if ('number' not in params) or (params['number'] is None):
            raise ValueError("Missing the required parameter `number` when calling `format_international`")
        # verify the required parameter 'provided_location' is set
        if ('provided_location' not in params) or (params['provided_location'] is None):
            raise ValueError("Missing the required parameter `provided_location` when calling `format_international`")
        # verify the required parameter 'dial_from_location' is set
        if ('dial_from_location' not in params) or (params['dial_from_location'] is None):
            raise ValueError("Missing the required parameter `dial_from_location` when calling `format_international`")

        resource_path = '/v1/format/number/international/{number}/{providedLocation}/{dialFromLocation}'.replace('{format}', 'json')
        method = 'GET'

        path_params = {}
        if 'number' in params:
            path_params['number'] = params['number']
        if 'provided_location' in params:
            path_params['providedLocation'] = params['provided_location']
        if 'dial_from_location' in params:
            path_params['dialFromLocation'] = params['dial_from_location']

        query_params = {}
        if 'pretty' in params:
            query_params['pretty'] = params['pretty']

        header_params = {}

        form_params = {}
        files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type='NumberFormatterResponseModel',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def format_national(self, number, location, **kwargs):
        """
        Get national format number
        Provides the national (e.g. 01514962245) format variant of the provided E.164 (e.g. +441514962245)

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.format_national(number, location, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str number: Phone number in E.164 format (e.g. +441514962245). (required)
        :param str location: Two letter country code (e.g. US). (required)
        :param str pretty: Optional query parameter. If true, returned number will contain whitespace for readability (e.g. 0151 496 2245).
        :return: NumberFormatterResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['number', 'location', 'pretty']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method format_national" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'number' is set
        if ('number' not in params) or (params['number'] is None):
            raise ValueError("Missing the required parameter `number` when calling `format_national`")
        # verify the required parameter 'location' is set
        if ('location' not in params) or (params['location'] is None):
            raise ValueError("Missing the required parameter `location` when calling `format_national`")

        resource_path = '/v1/format/number/national/{number}/{location}'.replace('{format}', 'json')
        method = 'GET'

        path_params = {}
        if 'number' in params:
            path_params['number'] = params['number']
        if 'location' in params:
            path_params['location'] = params['location']

        query_params = {}
        if 'pretty' in params:
            query_params['pretty'] = params['pretty']

        header_params = {}

        form_params = {}
        files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type='NumberFormatterResponseModel',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def format_pretty(self, number, location, **kwargs):
        """
        Get pretty number
        Uses whitespace to provide human readable numbers

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.format_pretty(number, location, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str number: Phone number to format (e.g. 01514962245, 011441514962245, +441514962245). (required)
        :param str location: Two letter country code matching provided number format (e.g. GB). (required)
        :return: NumberFormatterResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['number', 'location']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method format_pretty" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'number' is set
        if ('number' not in params) or (params['number'] is None):
            raise ValueError("Missing the required parameter `number` when calling `format_pretty`")
        # verify the required parameter 'location' is set
        if ('location' not in params) or (params['location'] is None):
            raise ValueError("Missing the required parameter `location` when calling `format_pretty`")

        resource_path = '/v1/format/number/pretty/{number}/{location}'.replace('{format}', 'json')
        method = 'GET'

        path_params = {}
        if 'number' in params:
            path_params['number'] = params['number']
        if 'location' in params:
            path_params['location'] = params['location']

        query_params = {}

        header_params = {}

        form_params = {}
        files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type='NumberFormatterResponseModel',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def retrieve_locality_info(self, phone_number, **kwargs):
        """
        
        Retrieve locality info

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.retrieve_locality_info(phone_number, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str phone_number: Phone number (required)
        :return: LocalityInfoResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['phone_number']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retrieve_locality_info" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'phone_number' is set
        if ('phone_number' not in params) or (params['phone_number'] is None):
            raise ValueError("Missing the required parameter `phone_number` when calling `retrieve_locality_info`")

        resource_path = '/v1/locality-lookup/{phoneNumber}'.replace('{format}', 'json')
        method = 'GET'

        path_params = {}
        if 'phone_number' in params:
            path_params['phoneNumber'] = params['phone_number']

        query_params = {}

        header_params = {}

        form_params = {}
        files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type='LocalityInfoResponseModel',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def retrieve_tps(self, phone_number, **kwargs):
        """
        Check Telephone Preference Service
        Check if provided number is included in the Telephony Preference Service list. Returns true or false.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.retrieve_tps(phone_number, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str phone_number: Phone number to lookup in E.164 format or national format according to numberFormatLocation. (required)
        :param str number_format_location: Optional; ISO 3166-1 alpha-2 Two letter country code matching the origin of the provided number format, defaults to GB.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['phone_number', 'number_format_location']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retrieve_tps" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'phone_number' is set
        if ('phone_number' not in params) or (params['phone_number'] is None):
            raise ValueError("Missing the required parameter `phone_number` when calling `retrieve_tps`")

        resource_path = '/v1/recipient-preferences/tps/{phone_number}'.replace('{format}', 'json')
        method = 'GET'

        path_params = {}
        if 'phone_number' in params:
            path_params['phone_number'] = params['phone_number']

        query_params = {}
        if 'number_format_location' in params:
            query_params['numberFormatLocation'] = params['number_format_location']

        header_params = {}

        form_params = {}
        files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept([])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def send_sms(self, sms_outbound_send_response_model, **kwargs):
        """
        Send an SMS Text Message
        Send an SMS message from one of your TC numbers, or the default number (this can be found on the API Access settings on the TelecomsCloud website). SMS message is queued for delivery to the specified recipient, returning a unique reference on success. This reference can be used to check the status of the submitted message.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.send_sms(sms_outbound_send_response_model, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param SmsOutboundSendResponseModel sms_outbound_send_response_model: * to : string (required) - Number to send message to.  * from : string (required) - Recipient will receive the message as sent from this number, accepts E.164 numbers (with leading '+') or UK based number formatting by default.  * message : string (required) - Message to send to recipient, up to 160 chars.  * numberFormatLocation : string - Optional; ISO 3166-1 alpha-2 Two letter country code matching the location matching the provided number format, defaults to GB. (required)
        :return: SmsOutboundSendResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sms_outbound_send_response_model']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method send_sms" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'sms_outbound_send_response_model' is set
        if ('sms_outbound_send_response_model' not in params) or (params['sms_outbound_send_response_model'] is None):
            raise ValueError("Missing the required parameter `sms_outbound_send_response_model` when calling `send_sms`")

        resource_path = '/v1/sms/outbound'.replace('{format}', 'json')
        method = 'POST'

        path_params = {}

        query_params = {}

        header_params = {}

        form_params = {}
        files = {}

        body_params = None
        if 'sms_outbound_send_response_model' in params:
            body_params = params['sms_outbound_send_response_model']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type='SmsOutboundSendResponseModel',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def get_sms_status(self, sms_id, **kwargs):
        """
        
        Get sms status

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_sms_status(sms_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str sms_id: Sms ID (required)
        :return: SmsOutboundGetStatusResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sms_id']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_sms_status" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'sms_id' is set
        if ('sms_id' not in params) or (params['sms_id'] is None):
            raise ValueError("Missing the required parameter `sms_id` when calling `get_sms_status`")

        resource_path = '/v1/sms/outbound/{sms_id}/status'.replace('{format}', 'json')
        method = 'GET'

        path_params = {}
        if 'sms_id' in params:
            path_params['sms_id'] = params['sms_id']

        query_params = {}

        header_params = {}

        form_params = {}
        files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['Default']

        response = self.api_client.call_api(resource_path, method,
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=files,
                                            response_type='SmsOutboundGetStatusResponseModel',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response
