# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class FaxInfoModel(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        FaxInfoModel - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'from_number': 'str',
            'id': 'str',
            'page_count': 'int',
            'pointer': 'int',
            'received_date': 'str',
            'service_number': 'str',
            'tiff_bytes': 'int'
        }

        self.attribute_map = {
            'from_number': 'from_number',
            'id': 'id',
            'page_count': 'page_count',
            'pointer': 'pointer',
            'received_date': 'received_date',
            'service_number': 'service_number',
            'tiff_bytes': 'tiff_bytes'
        }

        self._from_number = None
        self._id = None
        self._page_count = None
        self._pointer = None
        self._received_date = None
        self._service_number = None
        self._tiff_bytes = None

    @property
    def from_number(self):
        """
        Gets the from_number of this FaxInfoModel.


        :return: The from_number of this FaxInfoModel.
        :rtype: str
        """
        return self._from_number

    @from_number.setter
    def from_number(self, from_number):
        """
        Sets the from_number of this FaxInfoModel.


        :param from_number: The from_number of this FaxInfoModel.
        :type: str
        """
        self._from_number = from_number

    @property
    def id(self):
        """
        Gets the id of this FaxInfoModel.


        :return: The id of this FaxInfoModel.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this FaxInfoModel.


        :param id: The id of this FaxInfoModel.
        :type: str
        """
        self._id = id

    @property
    def page_count(self):
        """
        Gets the page_count of this FaxInfoModel.


        :return: The page_count of this FaxInfoModel.
        :rtype: int
        """
        return self._page_count

    @page_count.setter
    def page_count(self, page_count):
        """
        Sets the page_count of this FaxInfoModel.


        :param page_count: The page_count of this FaxInfoModel.
        :type: int
        """
        self._page_count = page_count

    @property
    def pointer(self):
        """
        Gets the pointer of this FaxInfoModel.


        :return: The pointer of this FaxInfoModel.
        :rtype: int
        """
        return self._pointer

    @pointer.setter
    def pointer(self, pointer):
        """
        Sets the pointer of this FaxInfoModel.


        :param pointer: The pointer of this FaxInfoModel.
        :type: int
        """
        self._pointer = pointer

    @property
    def received_date(self):
        """
        Gets the received_date of this FaxInfoModel.


        :return: The received_date of this FaxInfoModel.
        :rtype: str
        """
        return self._received_date

    @received_date.setter
    def received_date(self, received_date):
        """
        Sets the received_date of this FaxInfoModel.


        :param received_date: The received_date of this FaxInfoModel.
        :type: str
        """
        self._received_date = received_date

    @property
    def service_number(self):
        """
        Gets the service_number of this FaxInfoModel.


        :return: The service_number of this FaxInfoModel.
        :rtype: str
        """
        return self._service_number

    @service_number.setter
    def service_number(self, service_number):
        """
        Sets the service_number of this FaxInfoModel.


        :param service_number: The service_number of this FaxInfoModel.
        :type: str
        """
        self._service_number = service_number

    @property
    def tiff_bytes(self):
        """
        Gets the tiff_bytes of this FaxInfoModel.


        :return: The tiff_bytes of this FaxInfoModel.
        :rtype: int
        """
        return self._tiff_bytes

    @tiff_bytes.setter
    def tiff_bytes(self, tiff_bytes):
        """
        Sets the tiff_bytes of this FaxInfoModel.


        :param tiff_bytes: The tiff_bytes of this FaxInfoModel.
        :type: int
        """
        self._tiff_bytes = tiff_bytes

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

